use std::error::Error;
use std::time::Duration;
use std::thread;
use rpi_embedded::uart::{Parity, Uart};

#[cfg(test)]
mod tests {
    use std::time::Duration;
    use std::error::Error;
    use std::thread;
    use rpi_embedded::uart::{Parity, Uart};
    #[test]
//    fn it_works() {
//	let mut x = 1;
//        println!("{:?}",assert_eq!(2 + 2, 4));
//	while (x == 1){
//	}
//    }
    fn uart_test ()-> Result<(), Box<dyn Error>> {
//	We send a message from the raspberry to the raspberry to be sure that uart is working - for that we need a wire between Tx and Rx
	let mut buffer = [0u8; 1];
	let mut test = [59u8;1]; //59 is "O" if we do the conversion
    	let mut uart = Uart::new(9600, Parity::None, 8, 1)?;

	uart.write(String::from("O")).unwrap();
    // Configure read() to block until at least 1 byte is received.
    	uart.set_read_mode(1, Duration::default())?;
	if (uart.read_bytes(&mut buffer)? > 0) & (buffer != [10u8;1]){
	    println!("{:?}", assert_eq!(buffer,test));
	}
	Ok(())
    }
}

struct GpsData {
    id    : String,
    time  : String,
    lat   : String,
    long  : String,
    nbSat : String,
    hdop  : String,
    alti  : String,
}

enum id {
    GPGGA,
    GPGSA,
    GPGSV,
    GPRMC,
    GPVTG,
}
fn main() -> Result<(), Box<dyn Error>> {
    // Connect to the primary UART and configure it for 115.2 kbit/s, no
    // parity bit, 8 data bits and 1 stop bit.
    let mut uart = Uart::new(9600, Parity::None, 8, 1)?;

    // Configure read() to block until at least 1 byte is received.
    uart.set_read_mode(1, Duration::default())?;

    let mut buffer = [1u8; 1];
    // let mut vec_of_u8 = vec![0u8;100];
    let mut vec_of_u8 = Vec::new();
    let mut i : u8 = 0;
    let mut j : u8 = 0;

    loop {
        // Fill the buffer variable with any incoming data.
        if uart.read_bytes(&mut buffer)? > 0 {
            vec_of_u8.push(buffer[0]);
            // println!("Received byte: {}",vec_of_u8[i as usize] );
            // println!("Received byte: {}",buffer[0]);
            // thread::sleep(Duration::from_millis(20000));
            i = i + 1;
            if (buffer[0] == 10){
                i = 0;
                let string_utf8_result = String::from_utf8(vec_of_u8.clone()).unwrap();
                let tokens:Vec<&str>=string_utf8_result.split(",").collect();
                println!("New message : {:?}", tokens[0]);
                if tokens[0] == "$GPGGA"{
                    let data = GpsData{
                        id    : tokens[0].to_string(),
                        time  : tokens[1].to_string(),
                        lat   : tokens[2].to_string(),
                        long  : tokens[4].to_string(),
                        nbSat : tokens[6].to_string(),
                        hdop  : tokens[7].to_string(),
                        alti  : tokens[8].to_string(),
                    };
                    // println!("lat : {}", data.lat);
                }   
                vec_of_u8 = vec![];

            }
        }
    }
    Ok(())
}
